-- ex3.	List of actors surname and name such that the actors 
-- played only in movies of a certain category

select a.first_name, a.last_name, c.name, count(*)
from sakila.actor a, sakila.film_actor fa, sakila.film_category fc, sakila.film f, sakila.category c
where a.actor_id = fa.actor_id and fa.film_id = f.film_id and f.film_id = fc.film_id and fc.category_id = c.category_id
group by a.actor_id, a.first_name, a.last_name
having count(distinct c.category_id) = 1;


-- ex4.	List of clients surname and name such that the clients 
-- rent the movie “CASABLANCA SUPER”
select distinct(c.customer_id), c.first_name, c.last_name
from sakila.customer c, sakila.rental r, sakila.inventory i, sakila.film f
where c.customer_id = r.customer_id and r.inventory_id = i.inventory_id 
and i.film_id = f.film_id and f.title = 'CASABLANCA SUPER';

-- ex5.	List for each film, the total rental amount in the weekend 
-- and the percentage of this amount compared to the total amount of 
-- rentals in any day of the week

create view totalRentals AS
select film_id, sum(p.amount) as total
from sakila.rental r, sakila.payment p, sakila.inventory i
where r.rental_id = p.rental_id and r.inventory_id=i.inventory_id
group by i.film_id;	

create view weekend_view AS
select film_id, sum(p.amount) as weekend
from sakila.rental r, sakila.payment p, sakila.inventory i
where r.rental_id = p.rental_id and r.inventory_id=i.inventory_id
and (dayofweek(p.payment_date) = 1 or dayofweek(p.payment_date) = 7)
group by i.film_id; 

select t.film_id, w.weekend/total, total,  weekend
from   weekend_view w, totalRentals t
where   t.film_id = w.film_id;
	  
-- ex6.	List for each film, the number of customers who rented it
select f.title, count(distinct(c.customer_id))
from sakila.customer c, sakila.rental r, sakila.inventory i, sakila.film f
where c.customer_id = r.customer_id and r.inventory_id = i.inventory_id and i.film_id = f.film_id
group by f.film_id
order by count(distinct(c.customer_id)) desc;

